using UnityEngine;
using System.Collections;


public class SBGC : MonoBehaviour {

	public static float deltaTime_mod= 1.0f;
	private float deltaTime_mod_save= 1.0f;

	private static SBGC instance;
	public static SBGC i {
        get {
            if (SBGC.instance == null) {
				SBGC.instance= (SBGC)GameObject.FindWithTag("GameController").GetComponent(typeof(SBGC));
                if (SBGC.instance == null) {
                    Debug.Log ("ERROR - No Instance of Game Controller");
	            }
            }
            return SBGC.instance;
        }
    }


	// AWAKE
	//
	public void Awake() {
		if (this.tag != "GameController") {
			Debug.LogError("ERROR - GameController does not have tag set correctly");
			Debug.Break();
		}
	}


	// TIME DELTA
	//
	public static float deltaTime {
		get {
			return SBGC.deltaTime_mod * Time.deltaTime;
		}
	}
	

	// DELTA SPEED
	//	
	public static float deltaSpeed {
		get {
			return SBGC.deltaTime_mod;
		}
		set {
			SBGC.deltaTime_mod= value;
		}
	}

	
	// PAUSE
	//
	public void Pause(bool pause) {
		if (deltaTime_mod > 0.0f) {
			deltaTime_mod_save= deltaTime_mod;
		}
		if (pause) {
			deltaTime_mod= 0.0f;
		} else {
			deltaTime_mod= deltaTime_mod_save;
		}
	}
}
